package weather;

import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.Map;
import java.util.SortedSet;

import javax.swing.JOptionPane;

import weather.model.PunctualForecast;
import weather.persistence.ForecastException;
import weather.persistence.WeatherIconException;
import weather.persistence.binary.MyWeatherIconLoader;
import weather.persistence.binary.WeatherIconLoader;
import weather.persistence.text.MyForecastReader;
//import weather.persistence.binary.WriteBinaryFile;
import weather.ui.MyController;
import weather.ui.WeatherFrame;

public class Program {

    public static void main(String[] args) {

	// WriteBinaryFile bin = new WriteBinaryFile();
	// bin.write();
	
//	DateFormat df = DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.SHORT, Locale.ITALY);
//	System.out.println(df.format(new Date()));

	try {
	    WeatherIconLoader iconloader = new MyWeatherIconLoader(
		    new FileInputStream("Icons.dat"));
	    MyForecastReader forecastReader = new MyForecastReader();
	    Map<String, SortedSet<PunctualForecast>> mappa = forecastReader.readAll(new FileReader("Forecasts.txt"));

	    MyController controller = new MyController(iconloader, mappa);
	    WeatherFrame frame = new WeatherFrame(controller);

	    frame.setVisible(true);
	} catch (IOException e) {
	    JOptionPane.showMessageDialog(
		    null,
		    "Errore di I/O - impossibile leggere i dati"
			    + e.getMessage());
	    // e.printStackTrace();
	} catch (ForecastException e) {
	    JOptionPane.showMessageDialog(null,
		    "Formato del file di testo errato - impossibile leggere i dati"
			    + e.getMessage());
	    // e.printStackTrace();
	} catch (WeatherIconException e) {
	    JOptionPane.showMessageDialog(null,
		    "Formato del file binario errato - impossibile leggere i dati"
			    + e.getMessage());
	    // e.printStackTrace();
	}

    }

}
