package weather.persistence.binary;

import java.io.EOFException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InvalidClassException;
import java.io.ObjectInputStream;
import java.util.HashMap;
import java.util.Set;

import weather.model.*;
import weather.persistence.WeatherIconException;

public class MyWeatherIconLoader implements WeatherIconLoader {
	private HashMap<String, WeatherIcon> map;
	private ObjectInputStream innerStream;

	@SuppressWarnings("unchecked")
	public MyWeatherIconLoader(InputStream stream) throws IOException,
			WeatherIconException {
		innerStream = new ObjectInputStream(stream);
		try {
			map = (HashMap<String, WeatherIcon>) innerStream.readObject();
			innerStream.close();
		} catch (ClassNotFoundException e) {
			throw new WeatherIconException("Dati non validi", e);
		} catch (InvalidClassException e) {
			throw new WeatherIconException("Dati non validi", e);
		} catch (EOFException e) {
			throw new WeatherIconException("File icone vuoto!", e);
		}
	}

	@Override
	public WeatherIcon getIcon(String descrizione) {
		String key = descrizione.toLowerCase();
		Set<String> keys = map.keySet();
		return (keys.contains(key)) ? map.get(key) : null;
	}

}
